#include "gps.h"

void waitToContinue()
{
	while(!(getStatusRegister()&0x80))
	;
}

void writeFlash(char data[])
{
	fillBuffer(data);
	writeBufferToFlash(0);
}

void writeBufferToFlash(unsigned int pos)
{
	SPI_MasterTransmitCont(0x88); //Buffer1 to memory command
	SPI_MasterTransmitCont((pos>>6)&0xFF); //Memorypospos
	SPI_MasterTransmitCont((pos<<2)&0xFF); //Memorypos
	SPI_MasterTransmit(0x00); //Bufferpos - don't care
}

void fillBuffer(char data[])
{
	unsigned int i;
	SPI_MasterTransmitCont(0x84); //BufferWrite to Buffer1 command
	SPI_MasterTransmitCont(0x00); //Dummybyte
	SPI_MasterTransmitCont(0x00); //Dummynibble + Adrressnibble
	SPI_MasterTransmitCont(0x00); //Adrressbyte

	for(i=0; i<253; i++)
	{
		SPI_MasterTransmitCont(data[i]);
	}
	SPI_MasterTransmit(data[253]);
}

void readBuffer(char result[])
{
	unsigned int i;
	SPI_MasterTransmitCont(0xD4);
	SPI_MasterTransmitCont(0x00);
	SPI_MasterTransmitCont(0x00);
	SPI_MasterTransmitCont(0x00);
	SPI_MasterTransmitCont(0x00);

	for(i=0; i<253; i++)
	{
		result[i] = SPI_MasterReceiveCont();
	}
	result[253] = SPI_MasterReceive();
}

char getStatusRegister()
{
	SPI_MasterTransmitCont(0xD7); //Read Status Register Command
	return SPI_MasterReceive();
}

void ReadFlash(unsigned int pos, unsigned char buffer[])
{
	unsigned int i;
	SPI_MasterTransmitCont(0xD2); //Direct Memory read command
	SPI_MasterTransmitCont((pos>>6)&0xFF); //Memorypospos
	SPI_MasterTransmitCont((pos<<2)&0xFF); //Memorypos
	SPI_MasterTransmitCont(0x00); //Pagepos - don't care
	SPI_MasterTransmitCont(0x00); //Clock Cycles
	SPI_MasterTransmitCont(0x00);
	SPI_MasterTransmitCont(0x00);
	SPI_MasterTransmitCont(0x00);
	for(i=0; i<65; i++)
	{
		buffer[i] = SPI_MasterReceiveCont();
	}
	buffer[65] = SPI_MasterReceive();
}
	
